(* HCoop Domtool (http://hcoop.sourceforge.net/)
 * Copyright (c) 2006, Adam Chlipala
 *
 * This program is free software; you can redistribute it and/or
 * modify it under the terms of the GNU General Public License
 * as published by the Free Software Foundation; either version 2
 * of the License, or (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 51 Franklin Street, Fifth Floor, Boston, MA  02110-1301, USA.
 *)

(* Network message data structures *)

structure MsgTypes = struct

datatype msg =
	 MsgOk
       (* Your request was processed successfully. *)
       | MsgError of string
       (* Your request went wrong in some way. *)
       | MsgConfig of string
       (* Configuration source code *)
       | MsgFile of Slave.file_status
       (* The status of a configuration file has changed. *)
       | MsgDoFiles
       (* Perform the actions associated with the MsgFiles sent previously. *)
       | MsgGrant of Acl.acl
       (* Grant a permission *)
       | MsgRevoke of Acl.acl
       (* Revoke a permission *)
       | MsgListPerms of string
       (* List all of a user's permissions *)
       | MsgPerms of (string * string list) list
       (* A response to MsgListPerms, giving a permission class and all values
	* for which the user is authorized in that class *)
       | MsgWhoHas of {class : string, value : string}
       (* Which users have this permission? *)
       | MsgWhoHasResponse of string list
       (* These are the users! *)
       | MsgMultiConfig of string list
       (* Multiple Domtool sources in dependency order *)

end
